<?php  
            include_once( $_SERVER['DOCUMENT_ROOT']."/static/includes/common.inc.php" );
            do_html_header("Documentation");
        ?><div id="content">
<div class="navheader">
<table width="100%" summary="Navigation header"><tr>
<td width="20%" align="left">
<a accesskey="p" href="cli-pegasus-rc-client.php">Prev</a> </td>
<td width="60%" align="center"><a accesskey="h" href="index.php">Table of Contents</a></td>
<td width="20%" align="right"> <a accesskey="n" href="cli-pegasus-run.php">Next</a>
</td>
</tr></table>
<hr>
</div>
<div lang="en" class="refentry">
<a name="cli-pegasus-remove"></a><div class="titlepage"></div>
<div class="refnamediv">
<h2>Name</h2>
<p>pegasus-remove — removes a workflow that has been planned and submitted using pegasus-plan and pegasus-run</p>
</div>
<div class="refsynopsisdiv">
<a name="pegasus-remove_synopsis"></a><h2>Synopsis</h2>
<div class="blockquote"><blockquote class="blockquote"><div class="literallayout"><p>pegasus-remove [<span class="strong"><strong>-d</strong></span> <span class="emphasis"><em>dagid</em></span>] [<span class="strong"><strong>-v</strong></span>] [<span class="emphasis"><em>rundir</em></span>]</p></div></blockquote></div>
</div>
<div class="refsect1">
<a name="pegasus-remove_description"></a><h2>Description</h2>
<p>The pegasus-remove command remove a submitted/running workflow that has
been planned and submitted using <span class="strong"><strong>pegasus-plan</strong></span> and <span class="strong"><strong>pegasus-run</strong></span>. The
command can be invoked either in the planned directory with no options
and arguments or just the full path to the run directory.</p>
<p>Another way to remove a workflow is with the pegasus-halt command.
The difference is that pegasus-halt will allow current jobs to
finish gracefully before stopping the workflow.</p>
</div>
<div class="refsect1">
<a name="pegasus-remove_options"></a><h2>Options</h2>
<p>By default pegasus-remove does not require any options or arguments if
invoked from within the planned workflow directory. If running the
command outside the workflow directory then a full path to the workflow
directory needs to be specified or the <span class="emphasis"><em>dagid</em></span> of the workflow to be
removed.</p>
<p><span class="strong"><strong>pegasus-remove</strong></span> takes the following options:</p>
<div class="variablelist"><dl class="variablelist">
<dt>
<span class="term">
<span class="strong"><strong>-d</strong></span> <span class="emphasis"><em>dagid</em></span>
, </span><span class="term">
<span class="strong"><strong>--dagid</strong></span> <span class="emphasis"><em>dagid</em></span>
</span>
</dt>
<dd>
The workflow dagid to remove
</dd>
<dt>
<span class="term">
<span class="strong"><strong>-v</strong></span>
, </span><span class="term">
<span class="strong"><strong>--verbose</strong></span>
</span>
</dt>
<dd>
Raises debug level. Each invocation increase the level by 1.
</dd>
<dt><span class="term">
<span class="emphasis"><em>rundir</em></span>
</span></dt>
<dd>
Is the full qualified path to the base directory containing the planned
workflow DAG and submit files. This is optional if pegasus-remove
command is invoked from within the run directory.
</dd>
</dl></div>
</div>
<div class="refsect1">
<a name="pegasus-remove_return_value"></a><h2>Return Value</h2>
<p>If the workflow is removed successfully pegasus-remove returns with
an exit code of 0. However, in case of error, a non-zero exit code
indicates problems. An error message clearly marks the cause.</p>
</div>
<div class="refsect1">
<a name="pegasus-remove_files"></a><h2>Files</h2>
<p>The following files are opened:</p>
<div class="variablelist"><dl class="variablelist">
<dt><span class="term">
<span class="strong"><strong>braindump</strong></span>
</span></dt>
<dd>
This file is located in the rundir. pegasus-remove uses this file
to find out paths to several other files.
</dd>
</dl></div>
</div>
<div class="refsect1">
<a name="pegasus-remove_environment_variables"></a><h2>Environment Variables</h2>
<div class="variablelist"><dl class="variablelist">
<dt><span class="term">
<span class="strong"><strong>PATH</strong></span>
</span></dt>
<dd>
The path variable is used to locate binary for <span class="strong"><strong>condor_rm</strong></span>.
</dd>
</dl></div>
</div>
<div class="refsect1">
<a name="pegasus-remove_see_also"></a><h2>See Also</h2>
<p>pegasus-plan(1), pegasus-run(1)</p>
</div>
<div class="refsect1">
<a name="pegasus-remove_authors"></a><h2>Authors</h2>
<p>Gaurang Mehta  &lt;gmehta at isi dot edu&gt;</p>
<p>Jens-S. Vöckler &lt;voeckler at isi dot edu&gt;</p>
<p>Pegasus Team <a class="ulink" href="http://pegasus.isi.edu" target="_top">http://pegasus.isi.edu</a></p>
</div>
</div>
<div class="navfooter">
<hr>
<table width="100%" summary="Navigation footer">
<tr>
<td width="40%" align="left">
<a accesskey="p" href="cli-pegasus-rc-client.php">Prev</a> </td>
<td width="20%" align="center"><a accesskey="u" href="cli.php">Up</a></td>
<td width="40%" align="right"> <a accesskey="n" href="cli-pegasus-run.php">Next</a>
</td>
</tr>
<tr>
<td width="40%" align="left" valign="top">pegasus-rc-client </td>
<td width="20%" align="center"><a accesskey="h" href="index.php">Table of Contents</a></td>
<td width="40%" align="right" valign="top"> pegasus-run</td>
</tr>
</table>
</div>
</div><?php  
            do_html_footer();
        ?>
